        subroutine The COMMON below is INCLUDEd in many routines
c       This subroutine  only keeps the common `COMAR0.CH' file.
c       CUT IT OUT AND PLACE ON YOUR HARD DISK,
c       if it is not already there.
c-------------------------------------------------------------------------------
c       COMAR0.CH =filename
        IMPLICIT REAL*8 (A-H,M,O-Z)
        PARAMETER (NMX=30,NMX2=2*NMX,NMX3=3*NMX,NMX4=4*NMX,
     &  NMX8=8*NMX,NMXm=NMX*(NMX-1)/2)
         COMMON/DataForRoutines1/X(NMX3),V(NMX3),WTTL,M(NMX),
     &   XC(NMX3),WC(NMX3),MC(NMX)
     &  ,XI(NMX3),VI(NMX3),MASS,RINV(NMXm),RSUM,INAME(NMX),N
      COMMON/DataForChainRoutinesTwo/MMIJ,CMX(3),CMV(3),ENERGY,CHTIME
      common/softening/ee,cmethod(3)
c--------------------------------------------------------------------------------
        END


          IMPLICIT REAL*8 (A-H,M,O-Z)
          COMMON/DIAGNOSTICS/GAMMA,H,IWR
          common/fictitime/stime
          common/softening/ee7,cmethod7(3)
        COMMON/DataForChainRoutinesTwo/MMIJ7,
     & CMX7(3),CMV7(3),ENERGY,CHTIME7 ! here only for ENERGY (i.e. diagno)
        common/externalcount/neval
        common/notneeded/rijnotneeded
            REAL*8 G0(3),G(3),X(100),V(100),M(30),cmet(3)
          LOGICAL NewCase
          CHARACTER*22 outfile
          common/collision/icollision
          icollision=0
          neval=0
          TIME=0.0
          DELTAT=1.
          IWR=1 ! write some info ( set -1 to not to get that..)
C         Initial values
        READ(5,*)IWR,N,DELTAT,TMAX,step,soft,cmet,cdum,outfile,Ixc
c example   -1   3  .1     80   0.0 0.0   1 0 0     0.0  output 1 
c three-B-problem, output inteval =0.1, max time=80, initial step =0 
c  soft =0 (no softening ), cmet =(1,0,0) = logH method, 
c  cdum not needed in this version, outfile= outputfile, 
c  Ixc= if =1 then exact outputtime (slow!) 
c          ee=soft**2 ! square of soft(ening)
          open(66,file=outfile)
          MASS=0.0
          DO I=1,N
          L=3*(I-1)
          READ(5,*)M(I),(X(L+K),K=1,3),(V(L+K),K=1,3)
          MASS=MASS+M(I)
          END DO
          call Reduce2cm(x,m,N) ! -> centre of mass; NOT NECESSARY
          call Reduce2cm(v,m,N) !        -"-
c         3.0 1.0 4.0 0.0 0.0 0.0 0.0  ! example data (Pythagorean)
c         4.0 -2.0 0.0 0.0 0.0 0.0 0.0
c         5.0 1.0 0.0 0.0 0.0 0.0 0.0
c         mass x y z  vx vy vz
C         Initial values
           ee=soft**2
           ee7=ee
          call   CONSTANTS OF MOTION(X,V,M,N,ENER0,G0,AL,ee)
           TCR=MASS**2.5/(2.*ABS(ENER0))**1.5
           ANGMO=ABS(ENER0)*TCR
          NewCase=.TRUE.
          KSMX=100000 ! only this many steps without return
c          Ixc=1 ! 1 for exact time, 0 for not exact time (read above)
          energy=ener0 ! for diagno only
            goto 200
100       CONTINUE
          call AR0_CHAIN 
     &   (N,X,V,M,TIME,DELTAT,STEP,NewCase,KSMX,soft,cmet,Ixc)
200       CONTINUE
c        Diagnostics
         call   CONSTANTS OF MOTION(X,V,M,N,ENER1,G,AL,ee)
171    format(1x,f8.3,3f15.10)
        cangmo=mass**2.5*sqrt(Al)/abs(Ener1)
      WRITE(6,123)TIME,(ENERGY-ENER1)/AL,
     & ((G(k)-G0(k))/cAngMO,k=3,3),1-ener0/ener1!,al,cangmo!,energy,ener1
         call flush(6)
123   FORMAT(1x,'T: ',F10.3,1p,5g10.2,2f16.10)
         write(66,234)time,(x(k),x(k+1),x(k+2),k=1,3*n,3)
          call flush(66)
234      format(1x,f12.3,1p,90g13.5)
2345     format(1x,f16.6,1p,33g16.8)
         IF(TIME.LT.TMAX)then
          GOTO 100
         else
         end if
         END


c----------------------------------------------------------
c    RELEVANT ROUTINES START HERE
c-----------------------------------------------------------
         SUBROUTINE AR0_CHAIN ! Pure N-Body code, no external effects.
     &  (NN,XX,VX,MX,TIME,DELTAT,STEP,NewCase,KSMX,soft,cmet,Ixc)
C        CHAIN INTEGRATION (using logH and/ot TTL and/or DIFSY2)
c        NN=# of bodies; XX=coords, VX=vels, MX=masses, TIME=time,
c        dettaT=time interval
c        STEP=stepsize (set=0 initially)
c        NewCase=.true. iff chain membership has changed
c        KSMX=max # of steps without return (use some large # )
c        soft =optional softening( U=1/sqrt(r**2+soft**2) )
c        cmet= 3-d vector that determines the method:
c         (1,0,0) =logH, (0,1,0)=TTL,(0,0,1)=DIFSY2 without t-tranformation
c        
c        Ixc = 1 => exact time, =0 no exact time but return after CHTIME>DELTAT

         INCLUDE 'COMAR0.CH'
         COMMON/DerOfTime/GTIME
         COMMON/DIAGNOSTICS/GAMMA,H,IWR
         common/omegacoefficients/OMEC(NMX,NMX)
         REAL*8 G0(3),XX(*),VX(*),MX(*),cmet(3)
         REAL*8 Y(200),SY(200)
         LOGICAL MUSTSWITCH,NewCase
         data ntrue,nfalse,nwritten/3*0/
         save
c          Initial constants of motion
           if(NewCase)then
           ntrue=ntrue+1
           else
           nfalse=nfalse+1
           end if
           if(ntrue.gt.nfalse+10.and.nwritten.eq.0)then
           nwritten=1
           write(6,*)char(7),char(7)
           write(6,*)' NewCase should be set .TRUE. only' 
           write(6,*)' in the very beginning of a new simulation'
           write(6,*)' NOT at every step!! (May reduce accuracy!!)'
           write(6,*)' even if it may look like the contrary.'
           end if
           if(NN.gt.NMX)then
           write(6,*)' THIS CODE CAN HANDLE ONLY ',NMX,' BODIES '
           write(6,*)' Yuo are trying to use N=',NN
           write(6,*)' Try increasing NMX in COMAR0.CH '
           write(6,*)' and increase some (large) dimensions elsewhere'
           write(6,*)' in the same proportion.  STOPPING'
           STOP
           end if
           if(cmet(1).eq.0.0)then
           write(6,*)' In this version cmethod(1) should not  be zero'
           write(6,*)cmet,' = cmethod(k),k=1,3 '
           write(6,*)' STOPPING '
           STOP
           end if
           if(deltat.eq.0.0 .and. Ixc .eq.1)then
           write(6,*)' You cannot use DELTA=0 and Ixc=1 '
           write(6,*)' since then every output will be at time=0 '
           write(6,*)' STOPPING '
           STOP
           end if
           CHTIME=0.0
           icollision=0
           IF(NewCase)THEN
            aitemax=0
            itemax=1
            itemax_used=0
           ee=soft**2  ! to common
           do k=1,3
           cmethod(k)=cmet(k) ! -"-
           end do
           clight=cl    ! -"-
           N=NN
           DO I=1,N
           M(I)=MX(I)
           END DO

           MMIJ=0.0
           DO I=1,N-1
           DO J=I+1,N
           MMIJ=MMIJ+M(I)*M(J)
           END DO
           END DO
           MMIJ=MMIJ/(N*(N-1)/2.d0)
           DO I=1,3*N
           X(I)=XX(I)
           V(I)=VX(I)
           END DO
           call CONSTANTS OF MOTION(X,V,M,N,ENERGY,G0,ALAG,ee)
           call FIND CHAIN INDICES
           IF(IWR.GT.0)WRITE(6,1232)time,(INAME(KW),KW=1,N)
           call INITIALIZE XC and WC
           if(cmethod(2).ne.0.0)call omegacoef
           STIME=0.0
           NewCase=.FALSE.
            WTTL=Wfunction()
           mmss=0
           do i=1,n-1
           do j=i+1,n
           mmss=mmss+m(i)*m(j)
           end do 
           end do
            stepi=mmss/sqrt(mass*Alag/mmss)
            gtime=1/Alag ! avoid division be zero
            if(step.eq.0.0)step=stepi
c            return
           END IF
           KSTEPS=0
           nzero=0
777        KSTEPS=KSTEPS+1
           call Take Y from XC WC (Y,Nvar)
           call Obtain Order of Y(SY)
           if(Ixc.eq.1) step=min(step,deltaT/GTIME)
           EPS=1.e-13
                                         stime=0
                                    f1=chtime-deltaT ! for exact time iteration
                                         d1=gtime
111        hold=step 
          call  DIFSYAB(Nvar,EPS,SY,step,stime,Y)
c-------------------------------------try to change the step (if zero)
            if(step.eq.0.0)then
                 nzero=nzero+1
                 write(6,*)' STEP=0!',char(7)
              if(nzero.gt.10)then
                 write(6,*)' STOP, step permanently =0 '
                 STOP
                 else
                  if(nzero.ne.nzero/2*2)then
                  step=hold*1.1d0  ! try increase
                  else
                  step=hold*.1d0   ! try decrease
                  end if
                write(6,*)' Trying again with h=',step
                goto 111
              end if
                 else
                 nzero=0
            end if
c--------------------------------------------------------

           call Put Y to XC WC  (Y,Nvar) 
            call CHECK SWITCHING CONDITIONS(MUST SWITCH)
            IF(MUST SWITCH)THEN
            call Chain Transformation !
            WTTL=Wfunction()
            call Take Y from XC WC(Y,Nvar)
              IF(IWR.GT.0) WRITE(6,1232)time+chtime,(INAME(KW),KW=1,N)

1232         FORMAT(1X,g12.4,' I-CHAIN',20I3)
             END IF ! MUST SWITCH
                                          f2=chtime-deltaT ! for exact time iteration 
                                          d2=gtime 
                                          x1=-stime
                                          x2=0.0
              DLT=DELTAT*(1-1.d-6)
      IF(CHTIME.LT.DLT.and.(KSTEPS.lt.KSMX)
     &  .and.(icollision.eq.0))goto 777
         if(KSTEPS.lt.KSMX .and.icollision.eq.0.and.Ixc.eq.1)then
        ! ITERATE TO EXACT OUTPUTTIME
        call Iterate2ExactTime(Y,Nvar,deltaT,f1,d1,f2,d2,x1,x2)
         end if
                call update x and v 
                 DO I=1,3*N
                 XX(I)=X(I)
                 VX(I)=V(I)
                 END DO
                 TIME=TIME+CHTIME
                 RETURN
        END
         subroutine Iterate2ExactTime(Y0,Nvar,deltaT,f1,d1,f2,d2,x1,x2)
         INCLUDE 'COMAR0.CH'
         COMMON/DerOfTime/GTIME
         REAL*8 Y(200),SY(200),Y0(*)
         data tiny/1.d-6/
         save
           it=0 
           hs=abs(x1-x2)
c                   write(6,*)' |x1-x2| =',hs,x1,deltat,x2
 1111     CONTINUE
c          it=it+1
         do i=1,nvar
         y(i)=y0(i)
         end do
         stime=0
         dx1=-f1/d1
         dx2=-f2/d2
         if(abs(dx1).lt.abs(dx2))then
         xnew=x1+dx1
         else
         xnew=x2+dx2
         end if
c          
         test=(x1-xnew)*(xnew-x2)
         if(test.lt.(-tiny*hs).or.(it+1).eq.(it+1)/5*5)then
         xnew=(x1+x2)/2 ! bisect if out of interval
c           write(6,*)' bisection ',it, x1-xnew,xnew-x2,test
c     &,' it x1-t,t-x2 tst'
          end if

          sfinal=xnew

         call Put Y to XC WC  (Y,Nvar)
c--------------------------------------------------------------------------
                  call Obtain Order of Y(SY)
                   eps=1.e-14
                   steppi=0
                   do k=1,5
                   step=sfinal-stime
                   if(abs(step).gt.1.e-6*abs(hs).or.k.eq.1)then !!!!
                   steppi=step
                   call  DIFSYAB(Nvar,EPS,SY,step,stime,Y)
                   it=it+1
                   else
                   goto 222
                   end if

                   end do
222               continue
                   call Put Y to XC WC  (Y,Nvar)
                 call UPDATE X AND V
                 fnew=chtime-deltaT
                 dfnew=gtime
c         keep it bracketed
           if(f1*fnew.le.0.0)then
            f2=fnew
            d2=dfnew
            x2=xnew
            else
            f1=fnew
            d1=dfnew
            x1=xnew
           end if
        if((abs(deltaT-chtime).gt.1.e-4*deltat).and.(it.lt.100))
     &     goto 1111
c ONE FINAL STEP SHOULD BE HERE (if above not-so-accurate test)          
c--------------------------------------------------------------------
           do i=1,Nvar
           y0(i)=y(i)
           end do
           call Put Y to XC WC  (Y,Nvar)
           call UPDATE X AND V
c           write(6,*)it,chtime-deltaT, ' ite T_error ',steppi
           return
           end

        subroutine LEAPFROG(STEP,Leaps,stime)
        implicit real*8 (a-h,M,o-z)
        save
        hs=step
        h2=hs/2
        call XCmotion(h2)
        stime=stime+h2
        do k=1,Leaps-1
        call WCmotion(hs)
        call XCmotion(hs)
        stime=stime+hs
        end do
        call WCmotion(hs)
        call XCmotion(h2)
        stime=stime+h2
        return
        end
        function Wfunction()
        INCLUDE 'COMAR0.CH'
         common/omegacoefficients/OMEC(NMX,NMX)
         save
                 OMEGA=0.0d0
         DO I=1,N-1
         DO J=I+1,N
         if(omec(i,j).ne.0.0)then
         RIJ=SQRT(SQUARE(X(3*I-2),X(3*J-2)))
         OMEGA=OMEGA+omec(i,j)/RIJ 
         end if
         END DO
         END DO
         Wfunction=OMEGA
         RETURN
         END
         subroutine omegacoef
        INCLUDE 'COMAR0.CH'
        common/omegacoefficients/OMEC(NMX,NMX)
        do i=1,N-1
        do j=i+1,N
          if(1.e-3*mmij.gt.m(i)*m(j).and.cmethod(2).ne.0.0)then
          OMEC(I,J)=mmij
          OMEC(J,I)=mmij 
        else
          OMEC(I,J)=0
          OMEC(J,I)=0
        end if
        end do
        end do
c        do i=1,N
c        write(6,123)i,(omec(i,j),j=1,N)
c        end do
c123     format(1x,i4,1p,12g10.2)
        return
        end


        SUBROUTINE XCMOTION(hs)
        INCLUDE 'COMAR0.CH'

        COMMON/DerOfTime/G
        COMMON/DIAGNOSTICS/GAMMA,H,IWR
         save
c        Te=-ENERGY
         if(cmethod(1).ne.0.0d0)then
                 Te=-ENERGY
        call EVALUATE V(V)
        do I=1,N
        I0=3*I-3
        Te=Te+M(I)*(V(I0+1)**2+V(I0+2)**2+V(I0+3)**2)/2
        end do
         end if ! cmethod(1).ne.0.0d0
        G=1/(Te*cmethod(1)+WTTL*cmethod(2)+cmethod(3)) ! = t'
        dT= hs*G
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XC(L+K)=XC(L+K)+WC(L+K)*dT
        END DO
        END DO
        CHTIME=CHTIME+dT
        do k=1,3
        cmx(k)=cmx(k)+dt*cmv(k)
        end do

        RETURN
        END

        SUBROUTINE  WCMOTION(hs)
        INCLUDE 'COMAR0.CH'
         common/omegacoefficients/OMEC(NMX,NMX)
         common/apuindex/ikir
        COMMON/DerOfTime/G
        COMMON/DIAGNOSTICS/GAMMA,H,IWR
         real*8 FC(NMX3),XAUX(3)
         real*8 F(NMX3),GOM(nmx3)
         save
         RSUM=0.0
         OMEGA=0.0d0 
         U=0
         do i=1,3*N
         f(i)=0
         GOM(i)=0
         end do
         DO I=1,N-1
         L=3*(I-1)
         RIJL2=xc(L+1)**2+xc(L+2)**2+xc(L+3)**2+ee
         RIJL=SQRT(RIJL2)
C        Evaluate RSUM for decisionmaking.
         RSUM=RSUM+RIJL
         RINV(I)=1.d0/RIJL
         U=U+MC(I)*MC(I+1)*RINV(I)
         A=RINV(I)**3
         i0=3*i-3
         j=i+1
         j0=3*j-3
          omeker=omec(iname(i),iname(j))
         do K=1,3
          AF=A*XC(I0+K)
         f(I0+k)=f(i0+k)+MC(J)*AF
         f(j0+k)=f(j0+k)-MC(I)*AF
      if(cmethod(2).ne.0.0d0.and.omeker.ne.0.0)then
         GOM(I0+k)=GOM(I0+k)+AF*omeker
         GOM(J0+k)=GOM(J0+k)-AF*omeker
          end if
         end do
         if(cmethod(2).ne.0.0.and.omeker.ne.0.0)then
         OMEGA=OMEGA+omeker*RINV(I) 
         end if
         END DO

         LRI=N-1
C       Physical coordinates
        DO K=1,3
        XI(K)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XI(L+3+K)=XI(L+K)+XC(L+K) 
        END DO
        END DO
C        Non-chained contribution
        DO I=1,N-2
        LI=3*(I-1)
        DO J=I+2,N  
        LJ=3*(J-1)
        RIJ2=0.0+ee
          IF(J.GT.I+2)THEN
           DO K=1,3
           XAUX(K)=XI(LJ+K)-XI(LI+K)
           RIJ2=RIJ2+XAUX(K)**2
           END DO
           ELSE
           DO K=1,3
           XAUX(K)=XC(LI+K)+XC(LI+K+3)
           RIJ2=RIJ2+XAUX(K)**2
           END DO
          END IF
        RIJ2INV=1./RIJ2
        LRI=LRI+1
        RINV(LRI)=SQRT(RIJ2INV)
          U=U+MC(I)*MC(J)*RINV(LRI)
          omeker=omec(iname(i),iname(j))
          if(omeker.ne.0.0.and.cmethod(2).ne.0.0)then
          OMEGA=OMEGA+omeker*RINV(LRI)
          end if
          DO K=1,3
          A=RINV(LRI)**3*XAUX(K)
          f(LI+K)=f(LI+K)+MC(J)*A 
          f(LJ+K)=f(LJ+K)-MC(I)*A
      if(cmethod(2).ne.0.0d0.and.omeker.ne.0.0)then
          GOM(LI+K)=GOM(LI+K)+A*omeker
          GOM(LJ+K)=GOM(LJ+K)-A*omeker
            end if
          END DO
         END DO ! J=I+2,N
        END DO  ! I=1,N-2
         dT=hs/(U*cmethod(1)+OMEGA*cmethod(2)+cmethod(3)) 

                 do i=1,n-1
                 do k=1,3
                 L=3*(i-1)
                 fc(L+k)=f(3*i+k)-f(3*i+k-3)
                 end do
                 end do

        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        WC(L+K)=WC(L+K)+FC(L+K)*dT/2 ! first half \delta WC 
        END DO
        END DO
        call UPDATE X AND V  ! V+.5 dT N(R) is in V
c adding V-dependent perts.
               if(cmethod(2).ne.0.0d0)then
        dotW=0
        do I=1,N
        k0=3*I-3
        i0=3*iname(i)-3
        dotW=dotW+
     &  (V(I0+1)*GOM(k0+1)+V(I0+2)*GOM(K0+2)+V(I0+3)*GOM(K0+3))
        end do
                  WTTL=WTTL+dotW*dT 
                end if ! cmethod(2).ne.0.0
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        WC(L+K)=WC(L+K)+FC(L+K)*dT/2 ! second half \delta WC 
        END DO
        END DO
        RETURN
        END

        SUBROUTINE CHECK SWITCHING CONDITIONS(MUSTSWITCH)
        INCLUDE 'COMAR0.CH'
        LOGICAL MUSTSWITCH
        DATA Ncall,NSWITCH/0,200000000/
        save
        MUST SWITCH=.FALSE.
        Ncall=Ncall+1
C       Switch anyway after every NSWITCHth step.
        IF(Ncall.GE.NSWITCH)THEN
        Ncall=0
        MUST SWITCH=.TRUE.
        RETURN
        END IF
C       Inspect the structure of the chain.
C       NOTE: Inverse values 1/r are used instead of r itself.
        ADISTI=0.5*(N-1)/RSUM 
        LRI=N-1
        DO I=1,N-2
        DO J=I+2,N
        LRI=LRI+1
C       Do not inspect if 1/r is small.
        IF(RINV(LRI).GT.ADISTI)THEN
         IF(J-I.GT.2)THEN
C        Check for a dangerous long loop.
C          RINVMX=MAX(RINV(I-1),RINV(I),RINV(J-1),RINV(J))
           IF(I.GT.1)THEN
           RINVMX=MAX(RINV(I-1),RINV(I))
           ELSE
           RINVMX=RINV(1)
           END IF
           RINVMX=MAX(RINVMX,RINV(J-1))
           IF(J.LT.N)RINVMX=MAX(RINVMX,RINV(J))
           IF(RINV(LRI).GT.RINVMX)THEN
           MUST SWITCH=.TRUE.
           Ncall=0
           RETURN
           END IF
         ELSE
C        Is this a triangle with smallest size not regularised?
           IF( RINV(LRI).GT.MAX(RINV(I),RINV(I+1)))THEN
           MUST SWITCH=.TRUE.
           Ncall=0
           RETURN
           END IF
         END IF
        END IF
        END DO
        END DO
        RETURN
        END
         SUBROUTINE FIND CHAIN INDICES
         INCLUDE 'COMAR0.CH'
        REAL*8 RIJ2(NMXM)
        INTEGER IC(NMX2),IJ(NMXM,2),IND(NMXM)
        LOGICAL USED(NMXM),SUC,LOOP
        save
        L=0
        DO I=1,N-1
        DO J=I+1,N
        L=L+1
        RIJ2(L)=SQUARE(X(3*I-2),X(3*J-2))
        IJ(L,1)=I
        IJ(L,2)=J
        USED(L)=.FALSE.
        END DO
        END DO
        call ARRANGE(L,RIJ2,IND)
        LMIN=1+NMX
        LMAX=2+NMX
        IC(LMIN)=IJ(IND(1),1)
        IC(LMAX)=IJ(IND(1),2)
        USED(IND(1))=.TRUE.
1        DO I=2,L
        LI=IND(I)
        IF( .NOT.USED(LI))THEN
        call CHECK CONNECTION(IC,LMIN,LMAX,IJ,LI,SUC,LOOP)
        IF(SUC)THEN
        USED(LI)=.TRUE.
        GOTO 2
        ELSE
        USED(LI)=LOOP
        END IF
        END IF
        END DO
2        IF(LMAX-LMIN+1.LT.N)GO TO 1
        L=0
        DO I=LMIN,LMAX
        L=L+1
        INAME(L)=IC(I)
        END DO
        RETURN
        END
        SUBROUTINE CHECK CONNECTION(IC,LMIN,LMAX,IJ,LI,SUC,LOOP)
         INCLUDE 'COMAR0.CH'
        INTEGER IC(1),ICC(2),IJ(NMXM,2)
        LOGICAL SUC,LOOP
        save
        SUC=.FALSE.
        LOOP=.FALSE.
        ICC(1)=IC(LMIN)
        ICC(2)=IC(LMAX)
        DO I=1,2
        DO J=1,2
        IF(ICC(I).EQ.IJ(LI,J))THEN
        JC=3-J
        LOOP=.TRUE.
        DO L=LMIN,LMAX
        IF(IC(L).EQ.IJ(LI,JC))RETURN
        END DO
        SUC=.TRUE.
        LOOP=.FALSE.
        IF(I.EQ.1)THEN
        LMIN=LMIN-1
        IC(LMIN)=IJ(LI,JC)
        RETURN
        ELSE
        LMAX=LMAX+1
        IC(LMAX)=IJ(LI,JC)
        RETURN
        END IF
        END IF
        END DO
        END DO
        RETURN
        END
        SUBROUTINE ARRANGE(N,Array,Indx)
        implicit real*8 (a-h,o-z)
        dimension Array(1),Indx(1)
        save
        do 11 j=1,N
        Indx(j)=J
11      continue
        if(N.lt.2)RETURN
        l=N/2+1
        ir=N
10      CONTINUE
        IF(l.gt.1)THEN
        l=l-1
        Indxt=Indx(l)
        q=Array(Indxt)
        ELSE
        Indxt=Indx(ir)
        q=Array(Indxt)
        Indx(ir)=Indx(1)
        ir=ir-1
        IF(ir.eq.1)THEN
        Indx(1)=Indxt
        RETURN
        END IF
        END IF
        i=l
        j=l+l
20      IF(j.le.ir)THEN
            IF(j.lt.ir)THEN
               IF(Array(Indx(j)).lt.Array(Indx(j+1)))j=j+1
            END IF
            IF(q.lt.Array(Indx(j)))THEN
               Indx(i)=Indx(j)
               i=j
               j=j+j
            ELSE
               j=ir+1
            END IF
         GOTO 20
         END IF
         Indx(i)=Indxt
         GO TO 10
         END
        SUBROUTINE INITIALIZE XC AND WC
        INCLUDE 'COMAR0.CH'
        save
C        Center of mass
        DO K=1,3
        CMX(K)=0.0
        CMV(K)=0.0
        END DO
        MASS=0.0
        DO I=1,N
        L=3*(I-1)
        MC(I)=M(INAME(I)) ! masses along the chain
        MASS=MASS+MC(I)
         DO K=1,3
         CMX(K)=CMX(K)+M(I)*X(L+K)
         CMV(K)=CMV(K)+M(I)*V(L+K)
         END DO
        END DO
        DO K=1,3
        CMX(K)=CMX(K)/MASS
        CMV(K)=CMV(K)/MASS
        END DO
c       Rearange according toe chain indicies.
        DO I=1,N
        L=3*(I-1)
        LF=3*INAME(I)-3
         DO K=1,3
         XI(L+K)=X(LF+K)
         VI(L+K)=V(LF+K)
         END DO
        END DO

C       Chain coordinates & vels ! AND INITIAL `WTTL'
        WTTL=0            !  initialize W 
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XC(L+K)=XI(L+K+3)-XI(L+K)
        WC(L+K)=VI(L+K+3)-VI(L+K)
        END DO
        END DO
        RETURN
        END
        SUBROUTINE UPDATE X AND V
        INCLUDE 'COMAR0.CH'
        REAL*8 X0(3),V0(3)
        save
C        Obtain physical variables from chain quantities.

        DO K=1,3
        XI(K)=0.0
        VI(k)=0.0
        X0(K)=0.0
        V0(k)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        VI(L+3+K)=VI(L+K)+WC(L+K)
        XI(L+3+K)=XI(L+K)+XC(L+K)
        END DO
        END DO
        DO I=1,N
        L=3*(I-1)
        DO K=1,3
        V0(K)=V0(K)+VI(L+K)*MC(I)/MASS
        X0(K)=X0(K)+XI(L+K)*MC(I)/MASS
        END DO
        END DO
C        Rearrange according to INAME(i) and add CM.
        DO I=1,N
        L=3*(I-1)
        LF=3*(INAME(I)-1)
        DO K=1,3
        X(LF+K)=XI(L+K)-X0(K)+CMX(K)
        V(LF+K)=VI(L+K)-V0(K)+CMV(K)
        END DO
        END DO
        RETURN
        END
        SUBROUTINE CHAIN TRANSFORMATION
        INCLUDE 'COMAR0.CH'
        REAL*8 XCNEW(NMX3),WCNEW(NMX3)
        INTEGER IOLD(NMX)
        save
        L2=3*(INAME(1)-1)
        DO K=1,3
        X(L2+K)=0.0
        END DO
C       Xs are needed when determining new chain indices.
        DO I=1,N-1
        L=3*(I-1)
        L1=L2
        L2=3*(INAME(I+1)-1)
        DO K=1,3
        X(L2+K)=X(L1+K)+XC(L+K)
        END DO
        END DO
C        Store the old chain indices.
        DO I=1,N
        IOLD(I)=INAME(I)
        END DO

C       Find new ones.
        call FIND CHAIN INDICES

C       Construct new chain coordinates. Transformation matrix
C       (from old to new) has only coefficients -1, 0 or +1.
        DO I=1,3*(N-1)
        XCNEW(I)=0.0
        WCNEW(I)=0.0
        END DO
        DO ICNEW=1,N-1
C       Obtain K0 &  K1 such that iold(k0)=iname(icnew)
c                                 iold(k1)=iname(icnew+1)
        LNEW=3*(ICNEW-1)
        DO I=1,N
        IF(IOLD(I).EQ.INAME(ICNEW))K0=I
        IF(IOLD(I).EQ.INAME(ICNEW+1))K1=I
        END DO
        DO ICOLD=1,N-1
        LOLD=3*(ICOLD-1)
        IF( (K1.GT.ICOLD).AND.(K0.LE.ICOLD))THEN
C       ADD
        DO K=1,3
        XCNEW(LNEW+K)=XCNEW(LNEW+K)+XC(LOLD+K)
        WCNEW(LNEW+K)=WCNEW(LNEW+K)+WC(LOLD+K)
        END DO
        ELSEIF( (K1.LE.ICOLD).AND.(K0.GT.ICOLD) )THEN
C        SUBTRACT
        DO K=1,3
        XCNEW(LNEW+K)=XCNEW(LNEW+K)-XC(LOLD+K)
        WCNEW(LNEW+K)=WCNEW(LNEW+K)-WC(LOLD+K)
        END DO
        END IF
        END DO
        END DO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DO I=1,3*(N-1)   !!!!!!!!!!!!!!!!!!
        xc(i)=xcnew(i)   !!!!!!!!!!!!!!!!!!!
        wc(i)=wcnew(i)
        END DO           !!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C       Auxiliary quantities.
        MASS=0.0
        DO I=1,N
        MC(I)=M(INAME(I))
        MASS=MASS+MC(I)
        END DO

        RETURN
        END
        FUNCTION SQUARE(X,Y)
        implicit real*8 (a-h,m,o-z)
        REAL*8 X(3),Y(3),SQUARE
        common/softening/ee,cmethod(3)! only ee needed here
        save
        SQUARE=(X(1)-Y(1))**2+(X(2)-Y(2))**2+(X(3)-Y(3))**2+ee
        RETURN
        END
        SUBROUTINE CONSTANTS OF MOTION(X,Xd,M,NB,ENERGY,G,Alag,ee)
        IMPLICIT real*8 (A-H,m,O-Z)
        DIMENSION X(*),XD(*),G(*),M(*)
        save
        T=0.0
        U=0.0
        G(1)=0.
        G(2)=0.
        G(3)=0.
        RMIN=1.D30
        DO 10 I=1,NB
        K1=(I-1)*3+1
        K2=K1+1
        K3=K2+1
        T=T+.5d0*M(I)*(XD(K1)**2+XD(K2)**2+XD(K3)**2)
        G(1)=G(1)+M(I)*(X(K2)*XD(K3)-X(K3)*XD(K2))
        G(2)=G(2)-M(I)*(X(K1)*XD(K3)-X(K3)*XD(K1))
        G(3)=G(3)+M(I)*(X(K1)*XD(K2)-X(K2)*XD(K1))
        IF(I.EQ.Nb)GO TO 10
        J1=I+1
        DO 9 J=J1,Nb
        KI=(I-1)*3
        KJ=(J-1)*3
        R2=0.+ee
        DO 8 K=1,3
        KI=KI+1
        KJ=KJ+1
8       R2=R2+(X(KI)-X(KJ))**2
        U=U+M(I)*M(J)/SQRT(R2)
9       CONTINUE
10      CONTINUE
        ENERGY=T-U
        Alag=T+U
        RETURN
        END
        SUBROUTINE DIFSYAB(N,EPS,S,h,t,Y)
        implicit real*8 (a-h,o-z)
        parameter (NMX=200,NMX2=2*NMX,nmx27=nmx2*7) ! NMX=MAX(N),N=3*NB
        REAL*8 Y(N),YR(NMX2),YS(NMX2)
     +  ,DT(NMX2,7),D(7),S(N),EP(4)
        LOGICAL KONV,BO,KL,GR
        DATA EP/.4D-1,.16D-2,.64D-4,.256D-5/
        data dt/nmx27*0.0d0/
        save
        IF(EPS.LT.1.D-15)EPS=1.D-15
        IF(N.gt.NMX)write(6,*) ' too many variables!',char(7),'MAX=',NMX
        JTI=0
        FY=1
        redu=0.7d0
10      tN=t+H
        BO=.FALSE.
C
        M=1
        JR=2
        JS=3
        DO 260 J=1,6!12

        do i=1,N
        ys(i)=y(i)
        s(i)=max(abs(ys(i)),s(i)) 
        end do
C

        IF(BO)then
        D(2)=1.777777777777778D0
        D(4)=7.111111111111111D0
        D(6)=2.844444444444444D1
        else
        D(2)=2.25D0
        D(4)=9.D0
        D(6)=3.6D1
        end if

        IF(J.gt.7)then
        L=7
        D(7)=6.4D1
        else
        L=J
        D(L)=M*M
        end if

        KONV=L.GT.3
           subH=H/M
           call SubSteps(YS,subH,M) ! M substeps of size H/M.
        KL=L.LT.2
        GR=L.GT.5
        FS=0.

        DO 233 I=1,N 
        V=DT(I,1)
        C=YS(I)
        DT(I,1)=C
        TA=C
        IF(KL)GO TO 233
        DO  K=2,L
        B1=D(K)*V
        B=B1-C
        W=C-V
        U=V
        if(B.ne.0.0)then
        B=W/B
        U=C*B
        C=B1*B
        end if
        V=DT(I,K)
        DT(I,K)=U
        TA=U+TA
        END DO ! K=2,L
        SI=max(S(I),abs(TA))
        IF(DABS(YR(I)-TA).GT.SI*EPS) KONV=.FALSE.
        IF(GR.OR.SI.EQ.0.D0)GO TO 233
        FV=DABS(W)/SI
        IF(FS.LT.FV)FS=FV
233     YR(I)=TA
c       end of I-loop
        IF(FS.EQ.0.D0)GO TO 250
        FA=FY
        K=L-1
        FY=(EP(K)/FS)**(1.d0/FLOAT(L+K))
        fy=min(fy,2.d0)
        IF(L.EQ.2)GO TO 240
        IF(FY.LT.0.7*FA)GO TO 250
240     IF(FY.GT.0.7)GO TO 250
        H=H*FY
        JTI=JTI+1
        IF(JTI.GT.25)GO TO 30 !5->25
        GO TO 10
250     IF(KONV)GO TO 20
        D(3)=4.D0
        D(5)=1.6D1
        BO=.NOT.BO
        M=JR
        JR=JS
260     JS=M+M
        redu=redu*redu+.0001d0
        H=H*redu !  .5D0
        GO TO 10
20      t=tN
        H=H*FY
        DO  I=1,N
        Y(I)=YR(I)
        END DO

        RETURN
30      H=0.
        RETURN
        END
        subroutine SubSteps(Y,H,Leaps)
        implicit real*8 (a-h,m,o-z)
        real*8 Y(*)
        save
        call Put Y to XC WC  (Y,Nvar) ! Now Y is `written' to  Time,XC, WTTL, WC
        call  LEAPFROG(H,Leaps,stime) ! advance  CHTIME XC  WTTL WC 
        call Take Y from XC WC (Y,Nvars) ! take new results -> Y
        return
        end
        subroutine Put Y to XC WC (Y,Lmx)
         INCLUDE 'COMAR0.CH'
        real*8 Y(*)
        save
        L=1
        CHTIME=Y(L)
        do i=1,3*(N-1)
        L=L+1
        XC(I)=Y(L)
        end do
        L=L+1
        WTTL=Y(L)
        do i=1,3*(N-1)
        L=L+1
        WC(I)=Y(L)
        end do
        do i=1,3
        L=L+1
        CMX(I)=Y(L)
        end do
        do i=1,3
        L=L+1
        CMV(I)=Y(L)
        end do
        L=L+1
        ENERGY=Y(L)
        Lmx=L
        RETURN
        END
        subroutine Take Y from XC WC (Y,Nvar)
         INCLUDE 'COMAR0.CH'
        real*8 Y(*)
        save
        L=1
        Y(L)=CHTIME
        do i=1,3*(N-1)
        L=L+1   
        Y(L)=XC(I)
        end do
        L=L+1
        Y(L)=WTTL
        do i=1,3*(N-1)
        L=L+1
        Y(L)=WC(I)
        end do
        do i=1,3
        L=L+1
        Y(L)=CMX(I)
        end do
        do i=1,3
        L=L+1
        Y(L)=CMV(I)
        end do
        L=L+1
        Y(L)=ENERGY
        Nvar=L  
        RETURN
        END
        subroutine Obtain Order of Y(SY)
        INCLUDE 'COMAR0.CH'
        real*8 SY(*)
        save
        L=1
        SY(L)=ABS(CHTIME)
        SR=1.d66
        
        do i=1,N-1
        i0=3*i-3
        XCA=abs(XC(I0+1))+abs(XC(I0+2))+abs(XC(I0+3))
        SR=min(SR,XCA)
         do k=1,3 
         L=L+1
         SY(L)=XCA
         end do ! k
        end do  ! I
        L=L+1
        SY(L)=abs(WTTL)

        SW=sqrt(abs(Energy/mass))

        do i=1,N-1
        i0=3*i-3
        WCA=abs(WC(I0+1))+abs(WC(I0+2))+abs(WC(I0+3))
        SW=SW+WCA
        do k=1,3
        L=L+1
        SY(L)=WCA
        end do ! k
        end do ! i

        L=1
        do i=1,N-1
        i0=3*i-3
         do k=1,3 
         L=L+1
         SY(L)=SY(L)+1.d-4*SR
         end do ! k
        end do  ! I
        L=L+1 ! WTTL
        do i=1,N-1
        i0=3*i-3
        do k=1,3
        L=L+1
        SY(L)=SY(L)+1.d-4*SW
        end do ! k
        end do ! i


        CMXA=abs(cmx(1))+abs(cmx(2))+abs(cmx(3))+1.d-4*SR
        CMVA=abs(cmv(1))+abs(cmv(2))+abs(cmv(3))+1.d-4*SW

        do i=1,3
        L=L+1
        SY(L)=CMXA
        end do

        do i=1,3
        L=L+1
        SY(L)=CMVA
        end do

        L=L+1
        SY(L)=ABS(ENERGY)+MASS/SR *1.d-2
        SY(1)=SY(1)+sqrt(sr/mass)*sr*1.d-2
        RETURN
        END
        SUBROUTINE EVALUATE V(VN)
        INCLUDE 'COMAR0.CH'
        REAL*8 V0(3),VN(*)
        save
C        Obtain physical V's from chain quantities.

        DO K=1,3
        V0(k)=0.0
        VI(k)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        VI(L+3+K)=VI(L+K)+WC(L+K)
        END DO
        END DO
        DO I=1,N
        L=3*(I-1)
        DO K=1,3
        V0(K)=V0(K)+VI(L+K)*MC(I)/MASS
        END DO
        END DO
C        Rearrange according to INAME(i) and add CM.
        DO I=1,N
        L=3*(I-1)
        LF=3*(INAME(I)-1)
        DO K=1,3
        VN(LF+K)=VI(L+K)+(-V0(K)+CMV(K))
        END DO
        END DO
        RETURN
        END

        subroutine Reduce2cm(x,m,nb)
        real*8 x(*),m(*),cm(3)
        save
        cm(1)=0
        cm(2)=0
        cm(3)=0
        sm=0
        do i=1,nb
        sm=sm+m(i)
        do k=1,3
        cm(k)=cm(k)+m(i)*x(k+3*(i-1))
        end do
        end do
        do i=1,nb
        do k=1,3
        x(k+3*(i-1))=x(k+3*(i-1))-cm(k)/sm
        end do
        end do
        return
        end
