c        CODE: ARC5        
        subroutine This is  INCLUDEd in many routines
c       This subroutine  only keeps the common `COMARC.CH' file.
c       CUT IT OUT AND PLACE ON YOUR HARD DISK,
c       if it is not already there.
c-------------------------------------------------------------------------------
c       COMARC.CH =filename                                                    !
        IMPLICIT REAL*8 (A-H,M,O-Z)                                            !
        PARAMETER (NMX=30,NMX2=2*NMX,NMX3=3*NMX,NMX4=4*NMX,                    !
     &  NMX8=8*NMX,NMXm=NMX*(NMX-1)/2)                                         !
         COMMON/DataForRoutines1/X(NMX3),V(NMX3),WTTL,M(NMX),                  !
     &   XC(NMX3),WC(NMX3),MC(NMX)                                             !
     &  ,XI(NMX3),VI(NMX3),MASS,RINV(NMXm),RSUM,INAME(NMX),N                   !
      COMMON/DataForChainRoutinesTwo/MMIJ,CMX(3),CMV(3),ENERGY,CHTIME          !
      common/softening/ee,cmethod(3),Clight,NofBH                              !
      common/TIMECOMMON/Taika,timecomparison                                   !
c--------------------------------------------------------------------------------
        END

c       This version of AR-CHAIN allows  
c        EXTERNAL ACCELERATIONS (to be implemented by the user),
c        relativistic terms are implemented (not necessarily correct!),
c        just  give some non-zero value for the speed of light.
c
          IMPLICIT REAL*8 (A-H,M,O-Z)
          COMMON/DIAGNOSTICS/GAMMA,H,IWR
          common/fictitime/stime
          common/softening/ee7,cmethod7(3),Clight7,ISOJA
        COMMON/DataForChainRoutinesTwo/MMIJ7,
     & CMX7(3),CMV7(3),ENERGY,CHTIME7 ! here only for ENERGY (i.e. diagno)
        common/externalcount/neval
        common/notneeded/rijnotneeded
        common/justforfun/Tkin,Upot
            REAL*8 G0(3),G(3),X(100),V(100),M(30),cmet(3)
          LOGICAL NEWREG
          CHARACTER*22 outfile
          common/collision/icollision
          icollision=0
          neval=0
          TIME=0.0
          DELTAT=1.
          IWR=1 ! write some info ( set -1 to not to get that..)
C         Initial values
        READ(5,*)IWR,N,DELTAT,TMAX,step,soft,cmet,Clight,outfile,Ixc,NBH
c example   -1   3  .1     80   0.0 0.0   1 1.e-3 0  0.0    out 1  3
c three-B-problem, output inteval =0.1, max time=80, initial step =0 (estimated
c in TTLGCHAIN), sof =0 (no softening ), cmet =(1,1.e-3,0) = logH method+1.e-3*TTL,
c Clight = 0.0 => no relativistic terms, 'out'= outputfile for x, y, z.
c NBH= number of BH's (assumed to be bodies # 1,2,..NBH, irrelevant if C=0) 
          ee=soft**2 ! square of soft(ening)
          open(66,file=outfile)
          MASS=0.0
          DO I=1,N
          L=3*(I-1)
          READ(5,*)M(I),(X(L+K),K=1,3),(V(L+K),K=1,3)
          MASS=MASS+M(I)
          END DO
          call Reduce2cm(x,m,N)
          call Reduce2cm(v,m,N)
c         3.0 1.0 4.0 0.0 0.0 0.0 0.0  ! example data (Pythagorean)
c         4.0 -2.0 0.0 0.0 0.0 0.0 0.0
c         5.0 1.0 0.0 0.0 0.0 0.0 0.0
c         mass x y z  vx vy vz
C         Initial values
c          write(6,*) N,DELTAT, TMAX,step,soft,cmet,Clight,' ',outfile

          call   CONSTANTS OF MOTION(X,V,M,N,ENER0,G0,AL,ee)
           TCR=MASS**2.5/(2.*ABS(ENER0))**1.5
           ANGMO=ABS(ENER0)*TCR
          NEWREG=.TRUE.
          KSMX=100000 ! only this many steps without return
c          Ixc=1 ! 1 for exact time, 0 for not exact time
          energy=ener0 ! for diagno only
            goto 200
100       CONTINUE
          call AR_CHAIN 
     &   (N,X,V,M,TIME,DELTAT,STEP,NEWREG,KSMX,soft,cmet,clight,Ixc,NBH)
200       CONTINUE
c        Diagnostics
         call   CONSTANTS OF MOTION(X,V,M,N,ENER1,G,AL,ee)
171    format(1x,f8.3,3f15.10)
        cangmo=mass**2.5*sqrt(Al)/abs(Ener1)
                             amy=m(1)*m(2)/(m(1)+m(2))
                             rataRS=-Clight**2*amy/(4*Ener0) 
c           if(rataRS.lt.20..and.Clight.ne.0.0)KSMX=1
      WRITE(6,123)TIME,log((Tkin-ENERGY)/Upot),
     & (G(3)-G0(3))/cAngMO,1-ener0/ener1
         call flush(6)
123   FORMAT(1x,'T: ',F10.3,' dE/L: ',1p,5g10.2,0p,1x,i12)
         write(66,234)time,(x(k),x(k+1),x(k+2),k=1,3*n,3)
          call flush(66)
c          if(rataRS.lt.10.)then
c         write(67,2345)time,(x(k),x(k+1),k=1,3*2,3)
c          end if
234      format(1x,f12.3,1p,90g13.5)
2345     format(1x,f16.6,1p,33g16.8)
         IF(TIME.LT.TMAX .and. icollision.eq.0)then
          GOTO 100
         else
         end if
         END


c----------------------------------------------------------
c    RELEVANT ROUTINES START HERE
c-----------------------------------------------------------
         SUBROUTINE AR_CHAIN
     &  (NN,XX,VX,MX,TIME,DELTAT,STEP,NEWREG,KSMX,soft,cmet,cl,Ixc,NBH)
C        CHAIN INTEGRATION. Perturbations & CM-motion included (in principle).
c        NN=# of bodies; XX=coords, VX=vels, MX=masses, TIME=time,
c        dettaT=time interval
c        STEP=stepsize (set=0 initially)
c        NEWREG=.true. iff chain membership has changed
c        KSMX=max # of steps without return (use some large # )
c        soft =optional softening( U=1/sqrt(r**2+soft**2) )
c        cmet= 3-d vector that determines the method:
c         (1,0,0) =logH, (0,1,0)=TTL,(0,0,1)=DIFSY2 without t-tranformation
c        
c        cl=speed of light 
c        NOTE: cl=0 => no relativistic terms !!!
c        Ixc = 1 => exact time, =0 no exact time but return after CHTIME>DELTAT

         INCLUDE 'COMARC.CH'
         COMMON/DerOfTime/GTIME
         COMMON/DIAGNOSTICS/GAMMA,H,IWR
         common/omegacoefficients/OMEC(NMX,NMX)
         common/collision/icollision
         common/itemaxcommon/aitemax,itemax,itemax_used

         REAL*8 G0(3),XX(*),VX(*),MX(*),cmet(3)
         REAL*8 Y(200),SY(200)
         LOGICAL MUSTSWITCH,NEWREG
         data ntrue,nfalse,nwritten/3*0/
         save
c          Initial constants of motion
           if(newreg)then
           ntrue=ntrue+1
           else
           nfalse=nfalse+1
           end if
           if(ntrue.gt.nfalse+10.and.nwritten.eq.0)then
           nwritten=1
           write(6,*)char(7),char(7)
           write(6,*)' NEWREG should be set .TRUE. only' 
           write(6,*)' in the very beginning of a new simulation'
           write(6,*)' NOT at every step!! (May reduce accuracy!!)'
           write(6,*)' even if it may look like the contrary.'
           end if
           if(NN.gt.NMX)then
           write(6,*)' THIS CODE CAN HANDLE ONLY ',NMX,' BODIES '
           write(6,*)' Yuo are trying to use N=',NN
           write(6,*)' Try increasing NMX in COMARC.CH '
           write(6,*)' and increase some (large) dimensions elsewhere'
           write(6,*)' in the same proportion.  STOPPING'
           STOP
           end if
           if(cmet(1).eq.0.0 .and. cmet(2).ne.0.0)then
           write(6,*)' In this version cmethod(1) should not  be zero'
           write(6,*)' if cmethod(2).ne.0.0 '
           write(6,*)cmet,' = cmethod(k),k=1,3 '
           write(6,*)' STOPPING '
           STOP
           end if
           if(deltat.eq.0.0 .and. Ixc .eq.1)then
           write(6,*)' You cannot use DELTA=0 and Ixc=1 '
           write(6,*)' since then every output will be at time=0 '
           write(6,*)' STOPPING '
           STOP
           end if
           if(cmet(1)+cmet(2)+cmet(3).eq.0.0)then
           write(6,*)' You have not defined the time-transformation'
           write(6,*)cmet,' = cmethod(k),k=1,3 '
           write(6,*)' STOPPING '
           STOP
           end if

           CHTIME=0.0
           icollision=0
           Taika=TIME ! to common
           NofBH=NBH  ! - " -
           IF(NEWREG)THEN
            aitemax=0
            itemax=1
            itemax_used=0
           ee=soft**2  ! to common
           do k=1,3
           cmethod(k)=cmet(k) ! -"-
           end do
           clight=cl    ! -"-
           N=NN
           DO I=1,N
           M(I)=MX(I)
           END DO

           MMIJ=0.0
           DO I=1,N-1
           DO J=I+1,N
c           if(max(i,j).gt.NofBH) i
           MMIJ=MMIJ+M(I)*M(J)
           END DO
           END DO
           MMIJ=MMIJ/(N*(N-1)/2.d0)
           DO I=1,3*N
           X(I)=XX(I)
           V(I)=VX(I)
           END DO
           call CONSTANTS OF MOTION(X,V,M,N,ENERGY,G0,ALAG,ee)
           GTIME=1/ALAG
           call FIND CHAIN INDICES
           IF(IWR.GT.0)WRITE(6,1232)time,(INAME(KW),KW=1,N)
           call INITIALIZE XC and WC
           call omegacoef           
           STIME=0.0
           NEWREG=.FALSE.
            WTTL=Wfunction()
           mmss=0
           do i=1,n-1
           do j=i+1,n
           mmss=mmss+m(i)*m(j)
           end do 
           end do
            stepi=mmss/sqrt(mass*Alag/mmss)
            if(step.eq.0.0)step=stepi
c            return
           END IF
           KSTEPS=0
           nzero=0
777        KSTEPS=KSTEPS+1
           call Take Y from XC WC (Y,Nvar)
           call Obtain Order of Y(SY)
           if(Ixc.eq.1) step=min(step,deltaT/GTIME)
           EPS=1.e-13
                                         stime=0
                                    f1=chtime-deltaT ! for exact time iteration
                                         d1=gtime
111        hold=step 
          call  DIFSYAB(Nvar,EPS,SY,step,stime,Y)
c-------------------------------------try to change the step (if zero)
            if(step.eq.0.0)then
                 nzero=nzero+1
                 write(6,*)' STEP=0!',char(7)
              if(nzero.gt.10)then
                 write(6,*)' STOP, step permanently =0 '
                 STOP
                 else
                  if(nzero.ne.nzero/2*2)then
                  step=hold*1.1d0  ! try increase
                  else
                  step=hold*.1d0   ! try decrease
                  end if
                write(6,*)' Trying again with h=',step
                goto 111
              end if
                 else
                 nzero=0
            end if
c--------------------------------------------------------

               if(step.eq.0.0)then
               write(6,*)' STEP=0!',char(7)
               STOP ! nothing else can be done
               end if
           call Put Y to XC WC  (Y,Nvar) 
            call CHECK SWITCHING CONDITIONS(MUST SWITCH)
            IF(MUST SWITCH)THEN
            call Chain Transformation !
            WTTL=Wfunction()
            call Take Y from XC WC(Y,Nvar)
              IF(IWR.GT.0) WRITE(6,1232)time+chtime,(INAME(KW),KW=1,N)

1232         FORMAT(1X,g12.4,' I-CHAIN',20I3)
             END IF ! MUST SWITCH
                                          f2=chtime-deltaT ! for exact time iteration 
                                          d2=gtime 
                                          x1=-stime
                                          x2=0.0
              DLT=DELTAT*(1-1.d-6)
      IF(CHTIME.LT.DLT.and.(KSTEPS.lt.KSMX)
     &  .and.(icollision.eq.0))goto 777
         if(KSTEPS.lt.KSMX .and.icollision.eq.0.and.Ixc.eq.1)then
        ! ITERATE TO EXACT OUTPUTTIME
        call Iterate2ExactTime(Y,Nvar,deltaT,f1,d1,f2,d2,x1,x2)
         end if
                call update x and v 
                 DO I=1,3*N
                 XX(I)=X(I)
                 VX(I)=V(I)
                 END DO
                 TIME=TIME+CHTIME
                 RETURN
        END
         subroutine Iterate2ExactTime(Y0,Nvar,deltaT,f1,d1,f2,d2,x1,x2)
         INCLUDE 'COMARC.CH'
         COMMON/DerOfTime/GTIME
         REAL*8 Y(200),SY(200),Y0(*)
         data tiny/1.d-6/
         save
           it=0 
           hs=abs(x1-x2)
c                   write(6,*)' |x1-x2| =',hs,x1,deltat,x2
 1111     CONTINUE
c          it=it+1
         do i=1,nvar
         y(i)=y0(i)
         end do
         stime=0
         dx1=-f1/d1
         dx2=-f2/d2
         if(abs(dx1).lt.abs(dx2))then
         xnew=x1+dx1
         else
         xnew=x2+dx2
         end if
c          
         test=(x1-xnew)*(xnew-x2)
         if(test.lt.(-tiny*hs).or.(it+1).eq.(it+1)/5*5)then
         xnew=(x1+x2)/2 ! bisect if out of interval
c           write(6,*)' bisection ',it, x1-xnew,xnew-x2,test
c     &,' it x1-t,t-x2 tst'
          end if

          sfinal=xnew

         call Put Y to XC WC  (Y,Nvar)
c--------------------------------------------------------------------------
                  call Obtain Order of Y(SY)
                   eps=1.e-13
                   steppi=0
                   do k=1,5
                   step=sfinal-stime
                   if(abs(step).gt.1.e-6*abs(hs).or.k.eq.1)then !!!!
                   steppi=step
                   call  DIFSYAB(Nvar,EPS,SY,step,stime,Y)
                   it=it+1
                   else
                   goto 222
                   end if

                   end do
222               continue
                   call Put Y to XC WC  (Y,Nvar)
                 call UPDATE X AND V
                 fnew=chtime-deltaT
                 dfnew=gtime
c         keep it bracketed
           if(f1*fnew.le.0.0)then
            f2=fnew
            d2=dfnew
            x2=xnew
            else
            f1=fnew
            d1=dfnew
            x1=xnew
           end if
        if((abs(deltaT-chtime).gt.1.e-4*deltat).and.(it.lt.100))
     &     goto 1111
c ONE FINAL STEP SHOULD BE HERE (if above not-so-accurate test)          
c--------------------------------------------------------------------
           do i=1,Nvar
           y0(i)=y(i)
           end do
           call Put Y to XC WC  (Y,Nvar)
           call UPDATE X AND V
c           write(6,*)it,chtime-deltaT, ' ite T_error ',steppi
           return
           end

        subroutine LEAPFROG(STEP,Leaps,stime)
        implicit real*8 (a-h,M,o-z)
        save
        hs=step
        h2=hs/2
        call XCmotion(h2)
        stime=stime+h2
        do k=1,Leaps-1
        call WCmotion(hs)
        call XCmotion(hs)
        stime=stime+hs
        end do
        call WCmotion(hs)
        call XCmotion(h2)
        stime=stime+h2
        return
        end
        function Wfunction()
        INCLUDE 'COMARC.CH'
         common/omegacoefficients/OMEC(NMX,NMX)
         save
                 OMEGA=0.0d0
         DO I=1,N-1
         DO J=I+1,N
         if(omec(i,j).ne.0.0)then
         RIJ=SQRT(SQUARE(X(3*I-2),X(3*J-2)))
         OMEGA=OMEGA+omec(i,j)/RIJ 
         end if
         END DO
         END DO
         Wfunction=OMEGA
         RETURN
         END
         subroutine omegacoef
        INCLUDE 'COMARC.CH'
        common/omegacoefficients/OMEC(NMX,NMX)
        do i=1,N-1
        do j=i+1,N
          if(1.e-3*mmij.gt.m(i)*m(j).and.cmethod(2).ne.0.0)then
          OMEC(I,J)=mmij
          OMEC(J,I)=mmij
        else
          OMEC(I,J)=0
          OMEC(J,I)=0
        end if
        end do
        end do
        do i=1,N
        write(6,123)i,(omec(i,j),j=1,N)
        end do
123     format(1x,i4,1p,12g10.2)
        return
        end

        SUBROUTINE XCMOTION(hs)
        INCLUDE 'COMARC.CH'

        COMMON/DerOfTime/G
        COMMON/DIAGNOSTICS/GAMMA,H,IWR
         save
        Te=-ENERGY
         if(cmethod(1).ne.0.0d0)then
        call UPDATE X AND V
        do I=1,N
        I0=3*I-3
        Te=Te+M(I)*(V(I0+1)**2+V(I0+2)**2+V(I0+3)**2)/2
        end do
         end if ! cmethod(1).ne.0.0d0
        G=1/(Te*cmethod(1)+WTTL*cmethod(2)+cmethod(3)) ! = t'
        dT= hs*G
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XC(L+K)=XC(L+K)+WC(L+K)*dT
        END DO
        END DO
        CHTIME=CHTIME+dT
        do k=1,3
        cmx(k)=cmx(k)+dt*cmv(k)
        end do
        RETURN
        END

        SUBROUTINE  WCMOTION(hs)
        INCLUDE 'COMARC.CH'
         common/omegacoefficients/OMEC(NMX,NMX)
         common/apuindex/ikir
        COMMON/DerOfTime/G
        COMMON/DIAGNOSTICS/GAMMA,H,IWR
         real*8 FC(NMX3),XAUX(3)
         real*8 F(NMX3),df(nmx3),GOM(nmx3),dcmv(3),Va(nmx3),afc(nmx3)
         save
         RSUM=0.0
         OMEGA=0.0d0 
         U=0
         do i=1,3*N
         f(i)=0
         GOM(i)=0
         end do
         DO I=1,N-1
         L=3*(I-1)
         RIJL2=xc(L+1)**2+xc(L+2)**2+xc(L+3)**2+ee
         RIJL=SQRT(RIJL2)
C        Evaluate RSUM for decisionmaking.
         RSUM=RSUM+RIJL
         RINV(I)=1.d0/RIJL
         U=U+MC(I)*MC(I+1)*RINV(I)
         A=RINV(I)**3
         i0=3*i-3
         j=i+1
         j0=3*j-3
          omeker=omec(iname(i),iname(j))
         do K=1,3
          AF=A*XC(I0+K)
         f(I0+k)=f(i0+k)+MC(J)*AF
         f(j0+k)=f(j0+k)-MC(I)*AF
      if(cmethod(2).ne.0.0d0.and.omeker.ne.0.0)then
         GOM(I0+k)=GOM(I0+k)+AF*omeker
         GOM(J0+k)=GOM(J0+k)-AF*omeker
          end if
         end do
         if(cmethod(2).ne.0.0.and.omeker.ne.0.0)then
         OMEGA=OMEGA+omeker*RINV(I) 
         end if
         END DO

         LRI=N-1
C       Physical coordinates
        DO K=1,3
        XI(K)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XI(L+3+K)=XI(L+K)+XC(L+K) 
        END DO
        END DO
C        Non-chained contribution
        DO I=1,N-2
        LI=3*(I-1)
        DO J=I+2,N  
        LJ=3*(J-1)
        RIJ2=0.0+ee
          IF(J.GT.I+2)THEN
           DO K=1,3
           XAUX(K)=XI(LJ+K)-XI(LI+K)
           RIJ2=RIJ2+XAUX(K)**2
           END DO
           ELSE
           DO K=1,3
           XAUX(K)=XC(LI+K)+XC(LI+K+3)
           RIJ2=RIJ2+XAUX(K)**2
           END DO
          END IF
        RIJ2INV=1/RIJ2
        LRI=LRI+1
        RINV(LRI)=SQRT(RIJ2INV)
          U=U+MC(I)*MC(J)*RINV(LRI)
          omeker=omec(iname(i),iname(j))
          if(omeker.ne.0.0.and.cmethod(2).ne.0.0)then
          OMEGA=OMEGA+omeker*RINV(LRI)
          end if
          DO K=1,3
          A=RINV(LRI)**3*XAUX(K)
          f(LI+K)=f(LI+K)+MC(J)*A 
          f(LJ+K)=f(LJ+K)-MC(I)*A
      if(cmethod(2).ne.0.0d0.and.omeker.ne.0.0)then
          GOM(LI+K)=GOM(LI+K)+A*omeker
          GOM(LJ+K)=GOM(LJ+K)-A*omeker
            end if
          END DO
         END DO ! J=I+2,N
        END DO  ! I=1,N-2
         dT=hs/(U*cmethod(1)+OMEGA*cmethod(2)+cmethod(3)) 
                 do i=1,n-1
                 do k=1,3
                 L=3*(i-1)
                 fc(L+k)=f(3*i+k)-f(3*i+k-3)
                 end do
                 end do

        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        WC(L+K)=WC(L+K)+FC(L+K)*dT/2 ! first half \delta WC 
        END DO
        END DO
        call UPDATE X AND V  ! V+.5 dT N(R) is in V
c adding V-dependent perts.
              call Perturbations(dT,Va,dcmv,df) ! Va df .. 1 2 3 4  N 
                 do i=1,n-1
                 L=3*I-3
                 I1=3*INAME(I)-3
                 I2=3*INAME(I+1)-3
                 do k=1,3
                 afc(L+k)=df(I2+k)-df(I1+k) 
                 end do
                 end do

        dotE=0
        do I=1,N
        I0=3*I-3
        dotE=dotE+
     &    M(I)*(Va(I0+1)*df(i0+1)+Va(I0+2)*df(i0+2)+Va(I0+3)*df(i0+3)) ! %
        end do
                  ENERGY=ENERGY+dotE*dT
               if(cmethod(2).ne.0.0d0)then
        dotW=0
        do I=1,N
        k0=3*I-3
        i0=3*iname(i)-3
        dotW=dotW+
     &  (Va(I0+1)*GOM(k0+1)+Va(I0+2)*GOM(K0+2)+Va(I0+3)*GOM(K0+3))
        end do

                  WTTL=WTTL+dotW*dT 
                end if ! cmethod(2).ne.0.0
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        WC(L+K)=WC(L+K)+FC(L+K)*dT/2 +dt*afc(L+K) ! second half \delta WC +afc
        END DO
        END DO
c       cm-velocity variations  
        do k=1,3
        cmv(k)=cmv(k)+dT*dcmv(k)
        end do
        RETURN
        END
       subroutine EXTERNAL ACCELERATIONS(ACC) ! USER DEFINED
        INCLUDE 'COMARC.CH'
        
        common/perturbers/MP(100),XP(300),NPertur ! this MUST be changed by user
        real*8 ACC(*),dx(3)
        save
c       HERE ONE MUST EVALUATE THE ACCELERATIONS DUE TO THE PERTURBERS.
C       Physical positions and velocities (in the inertial coordinate)
C       system are in vectors X and V
C       (X(1)=X_1,X(2)=Y_1,X(3)=Z_1, X(4)=X_2, X(5)=Y_2,...)
C       After a call to this routine the EXAccerations
C       are assumed to be in the vector ACC.


          TrueTIME=Taika+CHTIME ! this is (?) the time to be used to obtain perturber coords
c                               ! note: chtime is measured from the beginning of this CHAIN call
c           these times are in common
        DO  I=1,3*N
        ACC(I)=0
        END DO
            if(1.eq.1) return ! AT THE MOMENT: NO PERTURBATINS
c        This is an example only:
         do ic=1,N ! ic= chainparticle index
         ic0=3*ic-3
         do i=1,Npertur ! i=perturber index
         i0=3*i-3
         rr=0
         do k=1,3 ! coordinate index
         !  XP(i0+k)=POLYNOM(TrueTime-StartingPoint) !predict the perturber coordinate.
         dx(k)=X(ic0+k)-XP(i0+k)
         rr=rr+dx(k)**2
         end do ! k
         rrr=sqrt(rr)*rr
         do k=1,3
                               MP(I)=0 ! REMOVE THIS for real use (0 for my tests)
         ACC(ic0+k)=ACC(ic0+k)-MP(I)/rrr*dx(k) ! hope this is correct (not confirmed)
         end do ! k
         end do ! i
         end do! ic         
c        end example

c         write(6,*)TrueTime,' TrueTime'
        return
        end

        subroutine Perturbations(dT,Va,dcmv,df)
        INCLUDE 'COMARC.CH'
        real*8 df(*),Va(*),dcmv(*),dfR(nmx3),acc(nmx3)
        common/itemaxcommon/aitemax,itemax,itemax_used
        common/externalcount/neval
        save
        absv=0
        call EXTERNAL ACCELERATIONS(ACC) ! perturber effects
        do i=1,3*N ! initialize
        Va(i)=V(i)+dT*ACC(I)/2 ! add v-independent ACC
        absv=absv+abs(V(i))
        df(i)=acc(i)
        end do
          neval=neval+1
                 if(Clight.ne.0.0)then ! include only if Clight set >0
        do itera=1,itemax
         itemax_used=itera
        call Relativistic ACCELERATIONS(dfr,Va)! Relativistic effects 
        do i=1,3*n
         df(i)=acc(i)+dfr(i) ! acc remains constant, dfr changes in this iteration
        end do
        tstv=0
        do i=1,3*N
        old=Va(i)
        Va(i)=V(i)+dT*df(i)/2
        tstv=tstv+abs(old-Va(i)) 
        end do ! i
        if(tstv.le.1.e-12*absv)goto 1
        end do ! itera
1       continue
                 end if ! Clight>0
        do k=1,3
        dcmv(k)=0
        end do
        do i=1,N
        i0=3*(I-1)
        do k=1,3
        dcmv(k)=dcmv(k)+m(i)*df(i0+k)/mass
        end do
        end do
        return
        end 
        SUBROUTINE CHECK SWITCHING CONDITIONS(MUSTSWITCH)
        INCLUDE 'COMARC.CH'
        LOGICAL MUSTSWITCH
        DATA Ncall,NSWITCH/0,200000000/
        save
        MUST SWITCH=.FALSE.
        Ncall=Ncall+1
C       Switch anyway after every NSWITCHth step.
        IF(Ncall.GE.NSWITCH)THEN
        Ncall=0
        MUST SWITCH=.TRUE.
        RETURN
        END IF
C       Inspect the structure of the chain.
C       NOTE: Inverse values 1/r are used instead of r itself.
        ADISTI=0.5*(N-1)/RSUM
        LRI=N-1
        DO I=1,N-2
        DO J=I+2,N
        LRI=LRI+1
C       Do not inspect if 1/r is small.
        IF(RINV(LRI).GT.ADISTI)THEN
         IF(J-I.GT.2)THEN
C        Check for a dangerous long loop.
C          RINVMX=MAX(RINV(I-1),RINV(I),RINV(J-1),RINV(J))
           IF(I.GT.1)THEN
           RINVMX=MAX(RINV(I-1),RINV(I))
           ELSE
           RINVMX=RINV(1)
           END IF
           RINVMX=MAX(RINVMX,RINV(J-1))
           IF(J.LT.N)RINVMX=MAX(RINVMX,RINV(J))
           IF(RINV(LRI).GT.RINVMX)THEN
           MUST SWITCH=.TRUE.
           Ncall=0
           RETURN
           END IF
         ELSE
C        Is this a triangle with smallest size not regularised?
           IF( RINV(LRI).GT.MAX(RINV(I),RINV(I+1)))THEN
           MUST SWITCH=.TRUE.
           Ncall=0
           RETURN
           END IF
         END IF
        END IF
        END DO
        END DO
        RETURN
        END
         SUBROUTINE FIND CHAIN INDICES
         INCLUDE 'COMARC.CH'
        REAL*8 RIJ2(NMXM)
        INTEGER IC(NMX2),IJ(NMXM,2),IND(NMXM)
        LOGICAL USED(NMXM),SUC,LOOP
        save
        L=0
        DO I=1,N-1
        DO J=I+1,N
        L=L+1
        RIJ2(L)=SQUARE(X(3*I-2),X(3*J-2))
        IJ(L,1)=I
        IJ(L,2)=J
        USED(L)=.FALSE.
        END DO
        END DO
        call ARRANGE(L,RIJ2,IND)
        LMIN=1+NMX
        LMAX=2+NMX
        IC(LMIN)=IJ(IND(1),1)
        IC(LMAX)=IJ(IND(1),2)
        USED(IND(1))=.TRUE.
1        DO I=2,L
        LI=IND(I)
        IF( .NOT.USED(LI))THEN
        call CHECK CONNECTION(IC,LMIN,LMAX,IJ,LI,SUC,LOOP)
        IF(SUC)THEN
        USED(LI)=.TRUE.
        GOTO 2
        ELSE
        USED(LI)=LOOP
        END IF
        END IF
        END DO
2        IF(LMAX-LMIN+1.LT.N)GO TO 1
        L=0
        DO I=LMIN,LMAX
        L=L+1
        INAME(L)=IC(I)
        END DO
        RETURN
        END
        SUBROUTINE CHECK CONNECTION(IC,LMIN,LMAX,IJ,LI,SUC,LOOP)
         INCLUDE 'COMARC.CH'
        INTEGER IC(1),ICC(2),IJ(NMXM,2)
        LOGICAL SUC,LOOP
        save
        SUC=.FALSE.
        LOOP=.FALSE.
        ICC(1)=IC(LMIN)
        ICC(2)=IC(LMAX)
        DO I=1,2
        DO J=1,2
        IF(ICC(I).EQ.IJ(LI,J))THEN
        JC=3-J
        LOOP=.TRUE.
        DO L=LMIN,LMAX
        IF(IC(L).EQ.IJ(LI,JC))RETURN
        END DO
        SUC=.TRUE.
        LOOP=.FALSE.
        IF(I.EQ.1)THEN
        LMIN=LMIN-1
        IC(LMIN)=IJ(LI,JC)
        RETURN
        ELSE
        LMAX=LMAX+1
        IC(LMAX)=IJ(LI,JC)
        RETURN
        END IF
        END IF
        END DO
        END DO
        RETURN
        END
        SUBROUTINE ARRANGE(N,Array,Indx)
        implicit real*8 (a-h,o-z)
        dimension Array(1),Indx(1)
        save
        do 11 j=1,N
        Indx(j)=J
11      continue
        if(N.lt.2)RETURN
        l=N/2+1
        ir=N
10      CONTINUE
        IF(l.gt.1)THEN
        l=l-1
        Indxt=Indx(l)
        q=Array(Indxt)
        ELSE
        Indxt=Indx(ir)
        q=Array(Indxt)
        Indx(ir)=Indx(1)
        ir=ir-1
        IF(ir.eq.1)THEN
        Indx(1)=Indxt
        RETURN
        END IF
        END IF
        i=l
        j=l+l
20      IF(j.le.ir)THEN
            IF(j.lt.ir)THEN
               IF(Array(Indx(j)).lt.Array(Indx(j+1)))j=j+1
            END IF
            IF(q.lt.Array(Indx(j)))THEN
               Indx(i)=Indx(j)
               i=j
               j=j+j
            ELSE
               j=ir+1
            END IF
         GOTO 20
         END IF
         Indx(i)=Indxt
         GO TO 10
         END
        SUBROUTINE INITIALIZE XC AND WC
        INCLUDE 'COMARC.CH'
        save
C        Center of mass
        DO K=1,3
        CMX(K)=0.0
        CMV(K)=0.0
        END DO
        MASS=0.0
        DO I=1,N
        L=3*(I-1)
        MC(I)=M(INAME(I)) ! masses along the chain
        MASS=MASS+MC(I)
         DO K=1,3
         CMX(K)=CMX(K)+M(I)*X(L+K)
         CMV(K)=CMV(K)+M(I)*V(L+K)
         END DO
        END DO
        DO K=1,3
        CMX(K)=CMX(K)/MASS
        CMV(K)=CMV(K)/MASS
        END DO
c       Rearange according toe chain indicies.
        DO I=1,N
        L=3*(I-1)
        LF=3*INAME(I)-3
         DO K=1,3
         XI(L+K)=X(LF+K)
         VI(L+K)=V(LF+K)
         END DO
        END DO

C       Chain coordinates & vels ! AND INITIAL `WTTL'
        WTTL=0            !  initialize W 
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        XC(L+K)=XI(L+K+3)-XI(L+K)
        WC(L+K)=VI(L+K+3)-VI(L+K)
        END DO
        END DO
        RETURN
        END
        SUBROUTINE UPDATE X AND V
        INCLUDE 'COMARC.CH'
        REAL*8 X0(3),V0(3)
        save
C        Obtain physical variables from chain quantities.

        DO K=1,3
        XI(K)=0.0
        VI(k)=0.0
        X0(K)=0.0
        V0(k)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        VI(L+3+K)=VI(L+K)+WC(L+K)
        XI(L+3+K)=XI(L+K)+XC(L+K)
        END DO
        END DO
        DO I=1,N
        L=3*(I-1)
        DO K=1,3
        V0(K)=V0(K)+VI(L+K)*MC(I)/MASS
        X0(K)=X0(K)+XI(L+K)*MC(I)/MASS
        END DO
        END DO
C        Rearrange according to INAME(i) and add CM.
        DO I=1,N
        L=3*(I-1)
        LF=3*(INAME(I)-1)
        DO K=1,3
        X(LF+K)=XI(L+K)-X0(K)+CMX(K)
        V(LF+K)=VI(L+K)-V0(K)+CMV(K)
        END DO
        END DO
        RETURN
        END
        SUBROUTINE CHAIN TRANSFORMATION
        INCLUDE 'COMARC.CH'
        REAL*8 XCNEW(NMX3),WCNEW(NMX3)
        INTEGER IOLD(NMX)
        save
        L2=3*(INAME(1)-1)
        DO K=1,3
        X(L2+K)=0.0
        END DO
C       Xs are needed when determining new chain indices.
        DO I=1,N-1
        L=3*(I-1)
        L1=L2
        L2=3*(INAME(I+1)-1)
        DO K=1,3
        X(L2+K)=X(L1+K)+XC(L+K)
        END DO
        END DO
C        Store the old chain indices.
        DO I=1,N
        IOLD(I)=INAME(I)
        END DO

C       Find new ones.
        call FIND CHAIN INDICES

C       Construct new chain coordinates. Transformation matrix
C       (from old to new) has only coefficients -1, 0 or +1.
        DO I=1,3*(N-1)
        XCNEW(I)=0.0
        WCNEW(I)=0.0
        END DO
        DO ICNEW=1,N-1
C       Obtain K0 &  K1 such that iold(k0)=iname(icnew)
c                                 iold(k1)=iname(icnew+1)
        LNEW=3*(ICNEW-1)
        DO I=1,N
        IF(IOLD(I).EQ.INAME(ICNEW))K0=I
        IF(IOLD(I).EQ.INAME(ICNEW+1))K1=I
        END DO
        DO ICOLD=1,N-1
        LOLD=3*(ICOLD-1)
        IF( (K1.GT.ICOLD).AND.(K0.LE.ICOLD))THEN
C       ADD
        DO K=1,3
        XCNEW(LNEW+K)=XCNEW(LNEW+K)+XC(LOLD+K)
        WCNEW(LNEW+K)=WCNEW(LNEW+K)+WC(LOLD+K)
        END DO
        ELSEIF( (K1.LE.ICOLD).AND.(K0.GT.ICOLD) )THEN
C        SUBTRACT
        DO K=1,3
        XCNEW(LNEW+K)=XCNEW(LNEW+K)-XC(LOLD+K)
        WCNEW(LNEW+K)=WCNEW(LNEW+K)-WC(LOLD+K)
        END DO
        END IF
        END DO
        END DO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        DO I=1,3*(N-1)   !!!!!!!!!!!!!!!!!!
        xc(i)=xcnew(i)   !!!!!!!!!!!!!!!!!!!
        wc(i)=wcnew(i)
        END DO           !!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C       Auxiliary quantities.
        MASS=0.0
        DO I=1,N
        MC(I)=M(INAME(I))
        MASS=MASS+MC(I)
        END DO

        RETURN
        END
        FUNCTION SQUARE(X,Y)
        implicit real*8 (a-h,m,o-z)
        REAL*8 X(3),Y(3),SQUARE
        common/softening/ee,cmethod(3),clight,NofBH ! only ee needed here
        save
        SQUARE=(X(1)-Y(1))**2+(X(2)-Y(2))**2+(X(3)-Y(3))**2+ee
        RETURN
        END
        SUBROUTINE CONSTANTS OF MOTION(X,Xd,M,NB,ENERGY,G,Alag,ee)
        IMPLICIT real*8 (A-H,m,O-Z)
        DIMENSION X(*),XD(*),G(*),M(*)
                common/justforfun/Tkin,Upot
        save
        T=0.0
        U=0.0
        G(1)=0.
        G(2)=0.
        G(3)=0.
        RMIN=1.D30
        DO 10 I=1,NB
        K1=(I-1)*3+1
        K2=K1+1
        K3=K2+1
        T=T+.5d0*M(I)*(XD(K1)**2+XD(K2)**2+XD(K3)**2)
        G(1)=G(1)+M(I)*(X(K2)*XD(K3)-X(K3)*XD(K2))
        G(2)=G(2)-M(I)*(X(K1)*XD(K3)-X(K3)*XD(K1))
        G(3)=G(3)+M(I)*(X(K1)*XD(K2)-X(K2)*XD(K1))
        IF(I.EQ.Nb)GO TO 10
        J1=I+1
        DO 9 J=J1,Nb
        KI=(I-1)*3
        KJ=(J-1)*3
        R2=0.+ee
        DO 8 K=1,3
        KI=KI+1
        KJ=KJ+1
8       R2=R2+(X(KI)-X(KJ))**2
        U=U+M(I)*M(J)/SQRT(R2)
9       CONTINUE
10      CONTINUE
        ENERGY=T-U
        Alag=T+U
        Tkin=T ! to justforfun
        Upot=U ! to justforfun
        RETURN
        END
        SUBROUTINE DIFSYAB(N,EPS,S,h,t,Y)
        implicit real*8 (a-h,o-z)
        parameter (NMX=200,NMX2=2*NMX,nmx27=nmx2*7) ! NMX=MAX(N),N=3*NB
        REAL*8 Y(N),YR(NMX2),YS(NMX2)
     +  ,DT(NMX2,7),D(7),S(N),EP(4)
        LOGICAL KONV,BO,KL,GR
        DATA EP/.4D-1,.16D-2,.64D-4,.256D-5/
        data dt/nmx27*0.0d0/
        save
        IF(EPS.LT.1.D-15)EPS=1.D-15
        IF(N.gt.NMX)write(6,*) ' too many variables!',char(7),'MAX=',NMX
        JTI=0
        FY=1
        redu=0.7d0
10      tN=t+H
        BO=.FALSE.
C
        M=1
        JR=2
        JS=3
        DO 260 J=1,12

        do i=1,N
        ys(i)=y(i)
        s(i)=max(abs(ys(i)),s(i)) 
        end do
C

        IF(BO)then
        D(2)=1.777777777777778D0
        D(4)=7.111111111111111D0
        D(6)=2.844444444444444D1
        else
        D(2)=2.25D0
        D(4)=9.D0
        D(6)=3.6D1
        end if

        IF(J.gt.7)then
        L=7
        D(7)=6.4D1
        else
        L=J
        D(L)=M*M
        end if

        KONV=L.GT.3
           subH=H/M
           call SubSteps(YS,subH,M) ! M substeps of size H/M.
        KL=L.LT.2
        GR=L.GT.5
        FS=0.

        DO 233 I=1,N 
        V=DT(I,1)
        C=YS(I)
        DT(I,1)=C
        TA=C
        IF(KL)GO TO 233
        DO  K=2,L
        B1=D(K)*V
        B=B1-C
        W=C-V
        U=V
        if(B.ne.0.0)then
        B=W/B
        U=C*B
        C=B1*B
        end if
        V=DT(I,K)
        DT(I,K)=U
        TA=U+TA
        END DO ! K=2,L
        SI=max(S(I),abs(TA))
        IF(DABS(YR(I)-TA).GT.SI*EPS) KONV=.FALSE.
        IF(GR.OR.SI.EQ.0.D0)GO TO 233
        FV=DABS(W)/SI
        IF(FS.LT.FV)FS=FV
233     YR(I)=TA
c       end of I-loop
        IF(FS.EQ.0.D0)GO TO 250
        FA=FY
        K=L-1
        FY=(EP(K)/FS)**(1.d0/FLOAT(L+K))
        fy=min(fy,1.4d0)
        IF(L.EQ.2)GO TO 240
        IF(FY.LT.0.7*FA)GO TO 250
240     IF(FY.GT.0.7)GO TO 250
        H=H*FY
        JTI=JTI+1
        IF(JTI.GT.25)GO TO 30 ! 5->25
        GO TO 10
250     IF(KONV)GO TO 20
        D(3)=4.D0
        D(5)=1.6D1
        BO=.NOT.BO
        M=JR
        JR=JS
260     JS=M+M
        redu=redu*redu+.001d0
        H=H*redu !  .5D0
        GO TO 10
20      t=tN
        H=H*FY
        DO  I=1,N
        Y(I)=YR(I)
        END DO

        RETURN
30      H=0.
        RETURN
        END
        subroutine SubSteps(Y,H,Leaps)
        implicit real*8 (a-h,m,o-z)
        real*8 Y(*),X(1000)
        common/softening/ee,cmethod(3),Clight,NofBh
        common/itemaxcommon/aitemax,itemax,itemax_used
        save
c  Here const. 0.001 and 0.999 and below aitemax.lt.3.0 may need adjustment
         aitemax=0.001d0*itemax_used+0.999d0*aitemax ! recent max of itera

        if(Clight.eq.0.or.aitemax.lt.3.)then !  <itera> >3. => inefficient (?)
        itemax=12
        call Put Y to XC WC  (Y,Nvar) ! Now Y is `written' to  Time,XC, WTTL, WC
        call  LEAPFROG(H,Leaps,stime) ! advance  CHTIME XC  WTTL WC 
        call Take Y from XC WC (Y,Nvars) ! take new results -> Y
        return
        else
         itemax=1  ! no iteration needed with this algorithm
          aitemax=12 ! no more going to iteration
        call Put Y to XC WC (Y,Nvars)
        call Take Y from XC WC (X,Nvars)! X=Y
        do K=1,Leaps
        call Axy(Y,X,H/2,Nvars)
        call Axy(X,Y,H/2,Nvars)
        end do
        end if
        return
        end
        subroutine Axy(X,Y,s,Nxy)
        implicit real*8 (a-h,o-z)
        real*8 X(*),Y(*),d(200)
        save
        call Put Y to XC WC (Y,Nvar) ! Y->common
        call lfd(+s,d) ! evaluate increments d(*) (forwards)
        do k=1,Nxy
        x(k)=x(k)+d(k)
        end do
        call Put Y to XC WC (X,Nvar) ! X->common
        call lfd(-s,d) ! evaluate increments d(*) (backwards)
        do k=1,Nxy
        y(k)=y(k)-d(k)
        end do
        return
        end 
        subroutine lfd(s,d)
        implicit real*8 (a-h,o-z)
        real*8 d(*),x(200),y(200)
        save
          call Take Y from XC WC (Y,Nvars) 
        call XCmotion(s/2)
        call WCmotion(s)
        call XCmotion(s/2)
         call Take Y from XC WC (X,Nvars)
         do k=1,Nvars
         d(k)=x(k)-y(k)
         end do
        return
        end
        subroutine Put Y to XC WC (Y,Lmx)
         INCLUDE 'COMARC.CH'
        real*8 Y(*)
        save
        L=1
        CHTIME=Y(L)
        do i=1,3*(N-1)
        L=L+1
        XC(I)=Y(L)
        end do
        L=L+1
        WTTL=Y(L)
        do i=1,3*(N-1)
        L=L+1
        WC(I)=Y(L)
        end do
        do i=1,3
        L=L+1
        CMX(I)=Y(L)
        end do
        do i=1,3
        L=L+1
        CMV(I)=Y(L)
        end do
        L=L+1
        ENERGY=Y(L)
        Lmx=L
        RETURN
        END
        subroutine Take Y from XC WC (Y,Nvar)
         INCLUDE 'COMARC.CH'
        real*8 Y(*)
        save
        L=1
        Y(L)=CHTIME
        do i=1,3*(N-1)
        L=L+1   
        Y(L)=XC(I)
        end do
        L=L+1
        Y(L)=WTTL
        do i=1,3*(N-1)
        L=L+1
        Y(L)=WC(I)
        end do
        do i=1,3
        L=L+1
        Y(L)=CMX(I)
        end do
        do i=1,3
        L=L+1
        Y(L)=CMV(I)
        end do
        L=L+1
        Y(L)=ENERGY
        Nvar=L  
        RETURN
        END
        subroutine Obtain Order of Y(SY)
        INCLUDE 'COMARC.CH'
        real*8 SY(*)
        save
        L=1
        SY(L)=ABS(CHTIME+Taika)
        SR=1.d66
        
        do i=1,N-1
        i0=3*i-3
        XCA=abs(XC(I0+1))+abs(XC(I0+2))+abs(XC(I0+3))
        SR=min(SR,XCA)
         do k=1,3 
         L=L+1
         SY(L)=XCA
         end do ! k
        end do  ! I
        L=L+1
        SY(L)=abs(WTTL)

        SW=sqrt(abs(Energy/mass))

        do i=1,N-1
        i0=3*i-3
        WCA=abs(WC(I0+1))+abs(WC(I0+2))+abs(WC(I0+3))
        SW=SW+WCA
        do k=1,3
        L=L+1
        SY(L)=WCA
        end do ! k
        end do ! i

        L=1
        do i=1,N-1
        i0=3*i-3
         do k=1,3 
         L=L+1
         SY(L)=SY(L)+1.d-4*SR
         end do ! k
        end do  ! I
        L=L+1 ! WTTL
        do i=1,N-1
        i0=3*i-3
        do k=1,3
        L=L+1
        SY(L)=SY(L)+1.d-4*SW
        end do ! k
        end do ! i


        CMXA=abs(cmx(1))+abs(cmx(2))+abs(cmx(3))+1.d-4*SR
        CMVA=abs(cmv(1))+abs(cmv(2))+abs(cmv(3))+1.d-4*SW

        do i=1,3
        L=L+1
        SY(L)=CMXA
        end do

        do i=1,3
        L=L+1
        SY(L)=CMVA
        end do

        L=L+1
        SY(L)=ABS(ENERGY)+MASS/SR *1.d-2
        SY(1)=SY(1)+sqrt(sr/mass)*sr*1.d-2
        RETURN
        END
        SUBROUTINE EVALUATE V(VN)
        INCLUDE 'COMARC.CH'
        REAL*8 V0(3),VN(*)
        save
C        Obtain physical V's from chain quantities.

        DO K=1,3
        V0(k)=0.0
        VI(k)=0.0
        END DO
        DO I=1,N-1
        L=3*(I-1)
        DO K=1,3
        VI(L+3+K)=VI(L+K)+WC(L+K)
        END DO
        END DO
        DO I=1,N
        L=3*(I-1)
        DO K=1,3
        V0(K)=V0(K)+VI(L+K)*MC(I)/MASS
        END DO
        END DO
C        Rearrange according to INAME(i) and add CM.
        DO I=1,N
        L=3*(I-1)
        LF=3*(INAME(I)-1)
        DO K=1,3
        VN(LF+K)=VI(L+K)-V0(K)+CMV(K)
        END DO
        END DO
        RETURN
        END

       SUBROUTINE Relativistic ACCELERATIONS(ACC,Va)
        INCLUDE 'COMARC.CH'
        REAL*8 ACC(*),dX(3),dW(3),dF(3),Va(*)
          common/collision/icollision
        common/notneeded/rijnotneeded
        save
        Cvalo=Clight! SPEED OF LIGHT 
C       INITIALIZE THE relativistic acceration(s) here. 
        DO 13 I=1,3*N
        ACC(I)=0.0
13      CONTINUE
        L=0
        DO I=1,N
        I3=3*I
        I2=I3-1
        I1=I3-2
        DO  J=I+1,N
        L=L+1
        J3=J+J+J
        J2=J3-1
        J1=J3-2
        dx(1)=X(J1)-X(I1)
        dx(2)=X(J2)-X(I2)
        dx(3)=X(J3)-X(I3)
        dw(1)=Va(J1)-Va(I1)
        dw(2)=Va(J2)-Va(I2)
        dw(3)=Va(J3)-Va(I3)
                        
        RIJ2=dx(1)**2+dx(2)**2+dx(3)**2
        rij=sqrt(rij2)
        RIJ3=RIJ2*rij
        rdotv=dx(1)*dw(1)+dx(2)*dw(2)+dx(3)*dw(3)
        vij2=dw(1)**2+dw(2)**2+dw(3)**2 


         CL= cvalo
c            if(rij.lt.3*RS)icollision=1
C            SQUARE OF MERGING DISTANCE (not implemented for now)
c           IF(RIJ2.LT.RIJ2MIN(I,J)*1.d-2)then
c           Ione=I
c           Itwo=J
c           Icoll=1
c           END IF
         IF(min(i,j).le.NofBH)THEN  ! only BH - BH, max->min => BH*
         call Relativistic Terms(dX,dW,rij,rdotv,vij2,m(i),m(j),cl,DF)
            RS=2.d0*(m(i)+m(j))/CL**2
cc            rijnotneeded=sqrt(VIJ2/CL**2)  ! diagno only
            rijnotneeded=rij/RS            ! diagno only
            if(rij.lt.3.*RS)write(6,*)' Near collision: r/RS',rij/RS ! diagno
            if(rij.lt.3.*RS)icollision=1   ! collision indicator
        ACC(I1)=ACC(I1)+m(j)*dF(1) ! here I assume action = reaction
        ACC(I2)=ACC(I2)+m(j)*dF(2) ! which is not really true for 
        ACC(I3)=ACC(I3)+m(j)*dF(3) ! relativistic terms (but who cares)
        ACC(J1)=ACC(J1)-m(i)*dF(1)
        ACC(J2)=ACC(J2)-m(i)*df(2)
        ACC(J3)=ACC(J3)-m(i)*dF(3)
                      END IF
        END DO ! J
        END DO ! I
         
        RETURN
        END
c**********************************************************************
         subroutine Relativistic terms(X,V,r,rdotv,v2,m1,m2,c,DV)
         implicit real*8 (a-h,m,o-z)
         real*8 X(3),V(3),DV(3),n(3),ny,nv,m1,m2,m
         real*8 dv2(3),dv4(3),dv5(3)
         data beta,gamma/1.d0,1.d0/
         save
          m=m1+m2

          my=m1*m2/m

          ny=my/m
          n(1)=x(1)/r
          n(2)=x(2)/r
          n(3)=x(3)/r
 
          nv=rdotv/r
          v4=v2*v2
           r2=r*r
                         IF(1.eq.1)THEN
           do i=1,3
          dv2(i)=m/c**2*n(i)/r2*(m/r*(2*(beta+gamma)+2*ny) ! 1/c**2 terms
     &    -v2*(gamma+3*ny)+3*ny/2*nv**2)
     &    +m*v(i)*nv/c**2/r**2*(2*gamma+2-2*ny)
           end do
         
          
          do i=1,3
          dv4(i)=1/c**4*(                               ! 1/c**4 terms
     & +ny*m*n(i)/r2*(-2*v4+1.5d0*v2*nv**2*(3-4*ny)-15*nv**4/8*(1-3*ny))
     & +m**2*n(i)/r**3*(v2/2*ny*(11+4*ny)+2*nv**2*(1+ny*(12+3*ny)))
     & +ny*m*v(i)/r**2*(8*v2*nv-3*nv**3/2*(3+2*ny))
     & -m**2/2/r**3*v(i)*nv*(4+43*ny)-m**3*n(i)/r**4*(9+87*ny/4) )
           end do
                  ELSE
                  do k=1,3
                  dv2(k)=0
                  dv4(k)=0
                  end do
                  END IF
           do i=1,3                         
           dv5(i)=ny/c**5*(   ! gravitational radiation terms
     &    -8*m**2/r**3/5*(v(i)*(v2+3*m/r)-n(i)*nv*(3*v2+17*m/3/r)))
           end do
           do i=1,3
           dv(i)=-1/m*(dv2(i)+dv4(i)+dv5(i))
           end do
          return
          end

        subroutine Reduce2cm(x,m,nb)
        real*8 x(*),m(*),cm(3)
        save
        cm(1)=0
        cm(2)=0
        cm(3)=0
        sm=0
        do i=1,nb
        sm=sm+m(i)
        do k=1,3
        cm(k)=cm(k)+m(i)*x(k+3*(i-1))
        end do
        end do
        do i=1,nb
        do k=1,3
        x(k+3*(i-1))=x(k+3*(i-1))-cm(k)/sm
        end do
        end do
        return
        end
